package mapper;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;

import model.GameGenre;



public class GameGenreMapper extends DBConnection {
	public static void update(GameGenre gameGenre) {
		int gameID = gameGenre.getGameID();
		String genre = gameGenre.getGenre();

		Connection connect = null;
		PreparedStatement preparedStatement = null;
		try {
			Class.forName("com.mysql.jdbc.Driver");
			connect = DriverManager.getConnection(mysqlServer);

			preparedStatement = connect
					.prepareStatement("update gamegenres set genre=? where g_id=?");
			preparedStatement.setString(1, genre);
			preparedStatement.setInt(2, gameID);
			preparedStatement.executeUpdate();
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			close(null, (Statement) preparedStatement, connect);
		}
	}

	public static void insert(GameGenre gameGenre) {
		int gameID = gameGenre.getGameID();
		String genre = gameGenre.getGenre();
		Connection connect = null;
		PreparedStatement preparedStatement = null;
		try {
			Class.forName("com.mysql.jdbc.Driver");
			connect = DriverManager.getConnection(mysqlServer);

			preparedStatement = connect
					.prepareStatement("insert into gamegenres(g_id, genre) values(?,?)");
			preparedStatement.setInt(1, gameID);
			preparedStatement.setString(2, genre);
			preparedStatement.executeUpdate();
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			close(null, (Statement) preparedStatement, connect);
		}

	}

	public static void delete(GameGenre gameGenre) {
		int gameID = gameGenre.getGameID();
		String query = "delete from gamegenres where gameID=" + gameID;
		sendQuery(query);
	}

	public static List<GameGenre> fetch(int id) throws SQLException { 
		String query = "select * from games where id=" + id;
		ResultSet resultSet = sendQuery(query);
		List<GameGenre> res = new ArrayList<GameGenre>();
		while(resultSet.next()){
			int gameID = resultSet.getInt("g_id");
			String genre = resultSet.getString("genre");
			res.add(new GameGenre(gameID, genre));
		}
		return res;
	}
}
