package mapper;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import model.Game;

public class GameMapper extends DBConnection {
	public static void update(Game game) {
		int id = game.getId();
		String name = game.getName();
		String pic = game.getPic();
		String description = game.getDescription();

		Connection connect = null;
		PreparedStatement preparedStatement = null;
		try {
			Class.forName("com.mysql.jdbc.Driver");
			connect = DriverManager.getConnection(mysqlServer);

			preparedStatement = connect
					.prepareStatement("update game set name=?, pic=?, discription=? where id=?");
			preparedStatement.setString(1, name);
			preparedStatement.setString(2, pic);
			preparedStatement.setString(3, description);
			preparedStatement.setInt(4, id);
			preparedStatement.executeUpdate();
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			close(null, (Statement) preparedStatement, connect);
		}
	}

	public static void insert(Game game) {
		String name = game.getName();
		String pic = game.getPic();
		String description = game.getDescription();
		Connection connect = null;
		PreparedStatement preparedStatement = null;
		try {
			Class.forName("com.mysql.jdbc.Driver");
			connect = DriverManager.getConnection(mysqlServer);

			preparedStatement = connect
					.prepareStatement("insert into games(name, pic, description) values(?,?,?)");
			preparedStatement.setString(1, name);
			preparedStatement.setString(2, pic);
			preparedStatement.setString(3, description);
			preparedStatement.executeUpdate();
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			close(null, (Statement) preparedStatement, connect);
		}

	}

	public static void delete(Game game) {
		int id = game.getId();
		String query = "delete from games where id=" + id;
		sendQuery(query);
	}

	public static Game fetch(int id) throws SQLException { 
		String query = "select * from games where id=" + id;
		ResultSet resultSet = sendQuery(query);
		if(resultSet.next()){
			String name = resultSet.getString("name");
			String pic = resultSet.getString("pic");
			String description = resultSet.getString("description");
			return new Game(id, name, pic, description);
		}
		else return null;
	}
}
