package mapper;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;

import model.Review;

public class ReviewMapper extends DBConnection {
	public static void update(Review review) {
		int gameID = review.getGameID();
		int userID = review.getUserID();
		String rev = review.getReview();
		double rating = review.getRating();

		Connection connect = null;
		PreparedStatement preparedStatement = null;
		try {
			Class.forName("com.mysql.jdbc.Driver");
			connect = DriverManager.getConnection(mysqlServer);

			preparedStatement = connect
					.prepareStatement("update reviews set review=?, rating=?  where g_id=? and u_id=?");
			preparedStatement.setString(1, rev);
			preparedStatement.setDouble(2, rating);
			preparedStatement.setInt(3, gameID);
			preparedStatement.setInt(4, userID);
			preparedStatement.executeUpdate();
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			close(null, (Statement) preparedStatement, connect);
		}
	}

	public static void insert(Review review) {
		int gameID = review.getGameID();
		int userID = review.getUserID();
		String rev = review.getReview();
		double rating = review.getRating();
		Connection connect = null;
		PreparedStatement preparedStatement = null;
		try {
			Class.forName("com.mysql.jdbc.Driver");
			connect = DriverManager.getConnection(mysqlServer);

			preparedStatement = connect
					.prepareStatement("insert into reviews(g_id, u_id, review, rating) values(?,?,?,?)");
			preparedStatement.setInt(1, gameID);
			preparedStatement.setInt(2, userID);
			preparedStatement.setString(3, rev);
			preparedStatement.setDouble(4, rating);
			preparedStatement.executeUpdate();
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			close(null, (Statement) preparedStatement, connect);
		}

	}

	public static void delete(Review review) {
		int gameID = review.getGameID();
		int userID = review.getUserID();
		String query = "delete from reviews where g_id=" + gameID
				+ " and u_id=" + userID;
		sendQuery(query);
	}

	public static Review fetch(int gameID, int userID) {
		String query = "select * from games where g_id=" + gameID
				+ " and u_id=" + userID;
		ResultSet resultSet = sendQuery(query);
		try {
			if (resultSet.next()) {
				String review = resultSet.getString("review");
				double rating = resultSet.getDouble("rating");
				return new Review(gameID, userID, review, rating);
			}
		} catch (Exception e) {

		}
		return null;
	}

	public static boolean check(Review review){
		if(fetch(review.getGameID(), review.getUserID())!= null) return true;
		else return false;
	}
}
