package mapper;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import model.User;

public class UserMapper extends DBConnection {
	public static void update(User user) {
		int id = user.getId();
		String name = user.getName();
		String password = user.getPassword();

		Connection connect = null;
		PreparedStatement preparedStatement = null;
		try {
			Class.forName("com.mysql.jdbc.Driver");
			connect = DriverManager.getConnection(mysqlServer);

			preparedStatement = connect
					.prepareStatement("update users set name=?, password=? where id=?");
			preparedStatement.setString(1, name);
			preparedStatement.setString(2, password);
			preparedStatement.setInt(3, id);
			preparedStatement.executeUpdate();
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			close(null, (Statement) preparedStatement, connect);
		}
	}

	public static void insert(User user) {
		String name = user.getName();
		String password = user.getPassword();
		Connection connect = null;
		PreparedStatement preparedStatement = null;
		try {
			Class.forName("com.mysql.jdbc.Driver");
			connect = DriverManager.getConnection(mysqlServer);

			preparedStatement = connect
					.prepareStatement("insert into users(name, password) values(?,?)");
			preparedStatement.setString(1, name);
			preparedStatement.setString(2, password);
			preparedStatement.executeUpdate();
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			close(null, (Statement) preparedStatement, connect);
		}

	}

	public static void delete(User user) {
		int id = user.getId();
		String query = "delete from users where id=" + id;
		sendQuery(query);
	}

	public static User fetch(int id) throws SQLException { 
		String query = "select * from users where id=" + id;
		ResultSet resultSet = sendQuery(query);
		if(resultSet.next()){
			String name = resultSet.getString("name");
			String password = resultSet.getString("password");
			return new User(id, name, password);
		}
		else return null;
	}
}
